unit TestFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, FileCtrl, ShFileOp;

type
	TForm1 = class(TForm)
	  ShFileOp1: TShFileOp;
	  OpenDialog1: TOpenDialog;
	  Button1: TButton;
	  Button2: TButton;
	  Label2: TLabel;
	  Button3: TButton;
	  Label3: TLabel;
	  ListBox1: TListBox;
	  procedure Button1Click(Sender: TObject);
	  procedure Button2Click(Sender: TObject);
	  procedure Button3Click(Sender: TObject);
	private
	  { Dclarations prives }
	public
	  { Dclarations publiques }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
	ListBox1.Items.Clear;
	{Choose one or more files}
	if OpenDialog1.Execute then
		if OpenDialog1.Files.Count > 0 then begin
			{one or more files selected}
			{The list of selected files from the dialog box is
			assigned the the FilesList property}
			ShFileOp1.FilesList.Assign(OpenDialog1.Files);
			{Show the list for the demo}
			ListBox1.Items.Assign(OpenDialog1.Files);
			{Enable button for next step}
			Button2.Enabled := True;
			Button3.Enabled := False;
			label2.Caption := '';
			label3.Caption := '';
		end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
	Dir: AnsiString;
begin
	{Select destination directory}
	if not SelectDirectory(Dir,[sdAllowCreate, sdPerformCreate],0) then exit;
	{Pass it to Destination property}
	ShFileOp1.Destination := Dir;
	Label2.Caption := Dir;
	{Enable button for next step}
	Button3.Enabled := true;
	label3.Caption := 'Ready';
end;

procedure TForm1.Button3Click(Sender: TObject);
var
	Msg: string;
begin
	Msg := '';
	{Perfoms copy}
	if not ShFileOp1.Execute then begin
	  {returned False: error}
	  Msg := 'An error occured';
	  Label3.Caption := 'Error';
	end else begin
	  {returned True}
		if ShFileOp1.Aborted then
			{the user aborted the operation}
			Msg := 'Aborted by user';
	end;
	if Msg <> '' then ShowMessage(Msg)
	else Label3.Caption := 'Operation complete';
	{Show that the list has been cleared}
	ListBox1.Items.Assign(ShFileOp1.FilesList);
end;

end.
